﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.Charting;
using Telerik.Windows.Controls;
using System.Collections;

namespace sl_Chart_ticket_532931
{
    public partial class MainPage : UserControl
    {
        const int AXISX_LABEL_STEP = 4;

        public MainPage()
        {
            InitializeComponent();

            this.ChangeDataContext();

            this.radChart1.DataBound += this.radChart1_DataBound;
            this.radChart1.DefaultView.ChartArea.AxisX.LabelStep = AXISX_LABEL_STEP;
        }

        private void ChangeDataContext()
        {
            ViewModel vm = new ViewModel();
            vm.AxisXLabelStep = AXISX_LABEL_STEP;
            vm.Data = this.GenerateRandomDataSource();
            this.DataContext = vm;
        }

        private List<TemperatureInfo> GenerateRandomDataSource()
        {
            Random r = new Random();
            DateTime now = new DateTime(2012, 4, 21);

            return new List<TemperatureInfo>() 
            { 
                new TemperatureInfo(){ Date = now.AddDays(r.Next(4, 7)),  TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(7, 14)),  TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(14, 21)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(21, 28)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(28, 35)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(35, 42)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(42, 49)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(49, 56)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(56, 63)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(63, 70)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(70, 77)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(77, 84)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(84, 91)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(91, 98)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(98, 105)), TempC = r.Next(10, 25), },
                new TemperatureInfo(){ Date = now.AddDays(r.Next(105, 111)),TempC = r.Next(10, 25), },
            };
        }

        void radChart1_DataBound(object sender, ChartDataBoundEventArgs e)
        {
            var chart = (RadChart)sender;
            var items = chart.ItemsSource as IEnumerable;
            int itemsCount = 0;
            foreach (var item in items)
                itemsCount++;

            this.radChart1.LayoutUpdated += radChart1_LayoutUpdated;
        }

        void radChart1_LayoutUpdated(object sender, EventArgs e)
        {
            if (this.HideBetweenTicks())
            {
                this.radChart1.LayoutUpdated -= this.radChart1_LayoutUpdated;
            }
        }

        private bool HideBetweenTicks()
        {
            var axisXPanel = Telerik.Windows.Controls.ChildrenOfTypeExtensions.ChildrenOfType<AxisXPanel>(this.radChart1.DefaultView.ChartArea).FirstOrDefault();

            if (axisXPanel == null)
                return false;

            for (int i = 0; i < axisXPanel.Children.Count; i++)
            {
                if (i % AXISX_LABEL_STEP != 0)
                    axisXPanel.Children[i].Visibility = Visibility.Collapsed;
            }

            return true;
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            this.ChangeDataContext();
        }
    }

    public class ViewModel
    {
        public List<TemperatureInfo> Data { get; set; }
        public List<TemperatureInfo> DataMinutes { get; set; }
        public int AxisXLabelStep { get; set; }
    }

    public class TemperatureInfo
    {
        public DateTime Date { get; set; }
        public int TempC { get; set; }
    }
}
